% This file generate the grouping matrix_k and packed constraint matrix pmatrix_constraint1
%from the sample path and the equal grouping rule. With parameter K=10,
%J=5000

clear;
clc;

%Assign the number of groups K:
K = 10;
J = 100;
path = importdata('sample_paths.txt');
matrix_path = path.data(1:1:J,:);
header = path.textdata;

%get the values of number of paths and the number of time periods.
[JJ,T] = size(matrix_path);

%Get the grouping matrix of every prices on path j
[matrix_path_sorted,IX] = sort(matrix_path);
for tt = 1:1:T
    for jj = 1:1:J
        IXX(IX(jj,tt),tt) = jj;
    end
end
matrix_k = ceil(IXX./(J/K));

%Print the matrix in the file and save it in vector_obj
%Generate the matrix in objective
clear j;
clear t;
clear vector_obj;
fid = fopen('pmatrix_obj.txt','w');
%Print the header of the file

matrix_obj = zeros(J,J*T+K*T+2);
for j = 1:1:J
    k = matrix_k(j,1);
    matrix_obj(j,T*J+K*T+1) = 1/J;
    matrix_obj(j,T*J+K*T+2) = -matrix_path(j,1);
    matrix_obj(j,T*J+T*(k-1)+1) = -matrix_path(j,1);
    for t = 2:1:T
        k = matrix_k(j,t);
        matrix_obj(j,T*(j-1)+t-1) = matrix_path(j,t);
        matrix_obj(j,T*J+T*(k-1)+t) = -matrix_path(j,t);
    end
    
end
print_pmatrix(fid,matrix_obj,J,T,K);
fclose('all');




clear j;
clear t;
clear pmatrix_constraint1;

%Prepare the file of matrix using in the non-additive constraint, here
%called consraint1.
%Print the header of the pmatrix file
pmatrix_constraint1 = zeros(J*T*2,3);
fid = fopen('pmatrix_constraint1.txt','w');
for j = 1:1:J
    for t = 1:1:T
fprintf(fid,'xi%d_%d\t',j,t);
    end
end
for k = 1:1:K
    for t = 1:1:T
    fprintf(fid,'x%d_%d\t', k,t);
    end
end
fprintf(fid,'\r\n');

%Print the values of matrix and store the data in pmatrix_constraint1
for j = 1:1:J
    for t = 1:1:T
        pmatrix_constraint1(2*T*(j-1)+2*(t-1)+1,1) = T*(j-1)+t;
        pmatrix_constraint1(2*T*(j-1)+2*(t-1)+1,2) = T*(j-1)+t;
        pmatrix_constraint1(2*T*(j-1)+2*(t-1)+1,3) = 1;
        fprintf(fid,'%d\t%d\t%d\r\n',T*(j-1)+t,T*(j-1)+t,-1);
        pmatrix_constraint1(2*T*(j-1)+2*(t-1)+2,1) = T*(j-1)+t;
        pmatrix_constraint1(2*T*(j-1)+2*(t-1)+2,2) = T*J+T*(matrix_k(j,t)-1)+t;
        pmatrix_constraint1(2*T*(j-1)+2*(t-1)+2,3) = -1;
        fprintf(fid,'%d\t%d\t%d\r\n',T*(j-1)+t,T*J+T*(matrix_k(j,t)-1)+t,1);
     end
end
fclose('all');






%Prepare the file using in constraint 2 (final value) and in constraint 3:
%non-additive constraint.
pmatrix_constraint2 = zeros(J*(T-1)*2,3);
%Print the header of constraint files
% % fid1 = fopen('pmatrix_constraint2.txt','w');
% for j = 1:1:J
%     for t = 1:1:T
% fprintf(fid1,'xi%d_%d\t',j,t);
%     end
% end
% for k = 1:1:K
%     for t = 1:1:T
%     fprintf(fid1,'x%d_%d\t', k,t);
%     end
% end
% fprintf(fid1,'\r\n');

fid2 = fopen('pmatrix_constraint2.txt','w');
for j = 1:1:J
    for t = 1:1:T
fprintf(fid2,'xi%d_%d\t',j,t);
    end
end
for k = 1:1:K
    for t = 1:1:T
    fprintf(fid2,'x%d_%d\t', k,t);
    end
end
fprintf(fid2,'\r\n');
%Calculate the values in the matrix.
clear i;
clear ii;
i = 1;
ii = 1;
for j = 1:1:J
    for t = 1:1:T
        
        if (t == T)
            pmatrix_constraint2(2*T*(j-1)+2*(t-1)+1,1) = i;
            pmatrix_constraint2(2*T*(j-1)+2*(t-1)+1,2) = T*(j-1)+t;
            pmatrix_constraint2(2*T*(j-1)+2*(t-1)+1,3) = 1;
%             fprintf(fid1,'%d\t%d\t%d\r\n',i,T*(j-1)+t,1);

            pmatrix_constraint2(2*T*(j-1)+2*(t-1)+2,1) = i+1;
            pmatrix_constraint2(2*T*(j-1)+2*(t-1)+2,2) = T*J+T*(matrix_k(j,t)-1)+t;
            pmatrix_constraint2(2*T*(j-1)+2*(t-1)+2,3) = 1;
%             fprintf(fid1,'%d\t%d\t%d\r\n',i+1,T*J+T*(matrix_k(j,t)-1)+t,1);
            i=i+2;
        else
            pmatrix_constraint3(2*T*(j-1)+2*(t-1)+1,1) = T*(j-1)+t;
            pmatrix_constraint3(2*T*(j-1)+2*(t-1)+1,2) = T*(j-1)+t;
            pmatrix_constraint3(2*T*(j-1)+2*(t-1)+1,3) = 1;
            fprintf(fid2,'%d\t%d\t%d\r\n',ii,T*(j-1)+t,1);

            pmatrix_constraint3(2*T*(j-1)+2*(t-1)+2,1) = T*(j-1)+t;
            pmatrix_constraint3(2*T*(j-1)+2*(t-1)+2,2) = T*(j-1)+t+1;
            pmatrix_constraint3(2*T*(j-1)+2*(t-1)+2,3) = -1;
            fprintf(fid2,'%d\t%d\t%d\r\n',ii,T*(j-1)+t+1,-1);
            ii = ii+1;

        end
     end
end

fclose('all');