%This script prepares the matrix in the objective of algorithm 2: to use
%ave_max_risk in psg solving the optimal exectuion problem. 
%There are T such packed matrix with size of (J*T,K*T) each row has two
%elements, and the corresponding pmatrix has the size of(J*T*2,3)

clear;
clc;
%Assign the number of groups K:
K = 10;
JJ = 5000;
path = importdata('sample_paths.txt');
matrix_path = path.data(1:1:JJ,:);
header = path.textdata;

%get the values of number of paths and the number of time periods.
[J,T] = size(matrix_path);

%Get the grouping matrix of every prices on path j
[matrix_path_sorted,IX] = sort(matrix_path);
for tt = 1:1:T
    for jj = 1:1:J
        IXX(IX(jj,tt),tt) = jj;
    end
end
matrix_k = ceil(IXX./(J/K));

%Initialization of matrix_obj(i,:,:)

matrix_obj =zeros(T,J*T,K*T+2);
    
for jt = 1:1:J*T
    j = ceil(jt/T);
    t = jt-(j-1)*T;
    k = matrix_k(j,t);
    matrix_obj(1,jt,(k-1)*T+t) = T*matrix_path(j,t);
    matrix_obj(1,jt,K*T+1) = 1/(J*T);
    matrix_obj(1,jt,K*T+2) = T*matrix_path(j,t);
end

for tau = 2:1:T
    tau1 = tau-1;
    for jt = 1:1:J*T
        matrix_obj(tau,jt,K*T+1) = 1/(J*T);
        j = ceil(jt/T);
        t = jt-(j-1)*T;
        kt = matrix_k(j,t); 
        ktau1 = matrix_k(j,tau1);
        if (tau-1 < t)
            matrix_obj(tau,jt,(kt-1)*T+t) = T*matrix_path(j,t);
            matrix_obj(tau,jt,T*(ktau1-1)+tau1) = -T*matrix_path(j,t);        
        else
            matrix_obj(tau,jt,K*T+2) = T*matrix_path(j,t);
           
        end
    end
end

fid(1) = fopen('pmatrix_obj_1.txt','w');
fid(2) = fopen('pmatrix_obj_2.txt','w');
fid(3) = fopen('pmatrix_obj_3.txt','w');
fid(4) = fopen('pmatrix_obj_4.txt','w');
fid(5) = fopen('pmatrix_obj_5.txt','w');

matrix_1(:,:) = matrix_obj(1,:,:);
matrix_2(:,:)= matrix_obj(2,:,:);
matrix_3(:,:)= matrix_obj(3,:,:);
matrix_4(:,:)= matrix_obj(4,:,:);
matrix_5(:,:)= matrix_obj(5,:,:);

print_pmatrix(fid(1),matrix_1,J,T,K);
print_pmatrix(fid(2),matrix_2,J,T,K);
print_pmatrix(fid(3),matrix_3,J,T,K);
print_pmatrix(fid(4),matrix_4,J,T,K);
print_pmatrix(fid(5),matrix_5,J,T,K);

fclose('all');
